//------------------------------------------------
// Copyright (C) 2012 Bo Xu <xuxbob@gmail.com>
//------------------------------------------------

#include "bpphistorydialog.h"
#include <QDir>
#include <QTextStream>
#include <QMessageBox>

BPPHistoryDialog::BPPHistoryDialog(const QString &bppHistory_FileName, const QFont &outputFont, QWidget *parent) :
    QDialog(parent)
{
    setupUi(this);

    QString bppHistory;
    QFile bppHistory_File(bppHistory_FileName);
    if( bppHistory_File.open(QIODevice::ReadOnly) ) {
        QTextStream bppHistoryIn(&bppHistory_File);
        bppHistory = bppHistoryIn.readAll();

        QString end_of_file = "// end of file";
        int position = bppHistory.lastIndexOf(end_of_file);
        if(position != -1)
            bppHistory.remove(position, bppHistory.size());
    }
    else
        bppHistory = tr("ERROR when open: %1").arg(QDir::toNativeSeparators(bppHistory_FileName));

    textEdit->setCurrentFont(outputFont);
    textEdit->setText(bppHistory);
}
